<?php
define('INIT_BB', true);
define('BB_SCRIPT', 'portal');
define('BB_ROOT', './');
require(BB_ROOT ."common.php");
require(INC_DIR ."bbcode.php");

$user->session_start();

$mode = htmlspecialchars(request_var('m', ''));
$start = isset($_GET['start']) ? abs(intval($_GET['start'])) : 0;
$per_page = '20';

where_user(array('page_id' => PAGE_PORTAL, 'id' => '0', 'mode' => '0', 'url' => str_replace($bb_cfg['script_path'], "", $_SERVER['REQUEST_URI']), 'title' => $lang['PORTAL_M']));
$page_cfg['include_bbcode_js'] = true;
if ($bb_cfg['portal_relizi']['on'])
{
	$errors = array();
	$join_sql = $url_mode ='';
	switch ($mode)
	{		
		case 'sc':
			$QickS = (isset($_GET['q']) || isset($_POST['q'])) ? true : false;
			$OptS  = (!empty($_GET['o']) || !empty($_POST['o'])) ? true : false;
			$CatS  = (!empty($_GET['c']) || !empty($_POST['c'])) ? true : false;
			$DateS = (!empty($_GET['d']) || !empty($_POST['d'])) ? true : false;
			
			if($OptS && $QickS)
			{
				$searchmode = (!empty($_POST['o'])) ? $_POST['o'] : $_GET['o'];
				
				switch ($searchmode)
				{	
					case 'title':
						if (!empty($_POST['q']) || !empty($_GET['q']))
						{
							$s_result = (!empty($_POST['q'])) ? $_POST['q'] : $_GET['q'];
							$s_iconv = iconv("CP1251", "UTF-8", $s_result);
							$si_result = prepare_message($s_iconv);
							$url_mode .= '&o=title&q='.urlencode($si_result);
							$Result = searchCheck($si_result, 3);
							
							$Result = explode(" ", $Result);
							foreach ($Result as $key => $value) {
								$dataResult[] = '+'.$value.'*';
							}
							$s_search = implode(" ", $dataResult);
						}else{
							$s_search = false;
						}
						
						if($s_search)
						{
						
							$join_sql .= "
								AND MATCH (t.topic_title) AGAINST ('". $s_search ."' IN BOOLEAN MODE)
							";
						}else{
							$errors[] = 'Текст заголовка не введен, или введен неверно.';
						}
					break;
					
					case 'text':
						if (!empty($_POST['q']) || !empty($_GET['q']))
						{
							$s_result = (!empty($_POST['q'])) ? $_POST['q'] : $_GET['q'];
							$s_iconv = iconv("CP1251", "UTF-8", $s_result);
							$si_result = prepare_message($s_iconv);
							$s_search = searchCheck($si_result);
							$url_mode .= '&o=text&q='.urlencode($s_search);
						}else{
							$s_result = false;
						}
						if($s_result)
						{
							if($getSTfile = CACHE('quick_cache','torrent')->search('text',$s_search))
							{
								$STextRes = get_from_array($getSTfile, $start, $per_page);
								$STextResSQL = implode(",", $STextRes);;
								$join_sql .= "
										AND t.topic_id IN($STextResSQL)
									";
							}else{
								$errors[] = 'Релиз не найден';
							}
						}else{
							$errors[] = 'Текст содержания не введен, или введен неверно.';
						}
					break;
					
					case 'user':
						if (!empty($_POST['q']) || !empty($_GET['q']))
						{
							$s_user_n = !empty($_POST['q']) ? $_POST['q'] : $_GET['q'];
							$s_user = get_user_id($s_user_n);
							$url_mode .= '&o=user&q='.urlencode($s_user_n);
						}else{
							$s_user = false;
						}
						if(!empty($s_user) && int_check($s_user))
						{
							$join_sql .= "
								AND u.user_id = ". $s_user ."%'
							";
						}else{
							$errors[] = 'Имя пользователя не введено, или не найдено.';
						}
					break;
					
					default:
						bb_die('Откуда такому моду взятся?');
				}	
			}
			if($CatS)
			{
				$s_cat = !empty($_POST['c']) ? $_POST['c'] : $_GET['c'];
				$url_mode .= '&c='.$s_cat;
				if(!empty($s_cat) && int_check($s_cat))
				{
					$join_sql .= "
						AND f.forum_id = $s_cat
					";
				}else{
					$errors[] = 'Категория не была выбрана.';
				}
			}
			if ($DateS)
			{
				$s_date = !empty($_POST['d']) ? $_POST['d'] : $_GET['d'];
				$time_massiv = explode(" ", $s_date);
				if(!empty($time_massiv[0])) $time_tmp1 = explode(".", $time_massiv[0]); else message_die(GENERAL_MESSAGE, "Ошибка при вводе даты (dmY)");
				if(!$s_time = mktime(0, 0, 0, $time_tmp1[1], $time_tmp1[0], $time_tmp1[2])) message_die(GENERAL_MESSAGE, "Ошибка при вводе даты (mk)");
				$url_mode .= '&d='.urlencode($s_date);
				if(!empty($s_time) && int_check($s_time))
				{
					$join_sql .= "
						AND tor.reg_time >= $s_time
					";
				}else{
					$errors[] = 'Дата не выбрана.';
				}
			}
			$excluded_forums_csv = $user->get_excluded_forums(AUTH_VIEW);
			$join_sql .= ($excluded_forums_csv) ? "
				AND f.forum_id NOT IN($excluded_forums_csv)
				AND f.forum_parent NOT IN($excluded_forums_csv)
			" : '';
			$url = 'portal.php?m=sc'.$url_mode;
		break;
		
		default:
		case 'vw':
			$excluded_forums_csv = $user->get_excluded_forums(AUTH_VIEW);
			$join_sql .= ($excluded_forums_csv) ? "
				AND f.forum_id NOT IN($excluded_forums_csv)
				AND f.forum_parent NOT IN($excluded_forums_csv)
			" : '';
			$url = 'portal.php?m=vw';
	}	
	$query =  "SELECT COUNT(t.topic_id) as count_topic
	FROM ". BB_BT_TORRENTS ." tor, ".BB_TOPICS." t, ". BB_FORUMS ." f
	WHERE t.topic_id = tor.topic_id
		AND tor.forum_id = f.forum_id
		$join_sql
	";
	if ( !($num = DB()->sql_query($query)) )
	{
		message_die(GENERAL_ERROR, 'Could not obtain portal information', '', __LINE__, __FILE__, $query);
	}
	$cont = DB()->sql_fetchrow($num);
	$count = ( $cont['count_topic'] ) ? $cont['count_topic'] : 0;
	if(!$count)
	{
		$template->assign_block_vars('tor_not', array());
	}else{		
		$sqlPortal = DB()->fetch_rowset("
			SELECT 
				t.topic_id, t.topic_title, t.topic_replies, 
				tor.tor_type, tor.attach_id, tor.reg_time, tor.tor_status, tor.size, 
				f.forum_name, f.forum_id, 
				u.username, u.user_id, u.user_level, u.user_rank
			FROM ". BB_BT_TORRENTS ." tor, ".BB_TOPICS." t, ". BB_FORUMS ." f, ".BB_USERS." u
			WHERE t.topic_id = tor.topic_id
				AND t.topic_poster = u.user_id
				AND tor.forum_id = f.forum_id
				$join_sql
			GROUP BY tor.reg_time DESC
			LIMIT $start, $per_page
			");
		$i=0;
		foreach ($sqlPortal as $rowP)
		{
			if($PortalRel = CACHE('quick_cache','torrent')->get($rowP['topic_id']))
			{
				$username =  profile_url(array('username' => $rowP['username'], 'user_id' => $rowP['user_id'], 'user_rank' => $rowP['user_rank']));

				// Gold/Silver releases mod
				$is_gold = '';
				if ($tr_cfg['gold_silver_enabled'])
				{
					if ($rowP['tor_type'] == TOR_TYPE_GOLD)
					{
						$is_gold = '<img src="images/tor_gold.gif" width="16" height="15" title="'.$lang['GOLD'].'" />&nbsp;';
					}
					elseif ($rowP['tor_type'] == TOR_TYPE_SILVER)
					{
						$is_gold = '<img src="images/tor_silver.gif" width="16" height="15" title="'.$lang['SILVER'].'" />&nbsp;';
					}
				}
				// END Gold/Silver releases mod
				// Иконка темы
				if($bb_cfg['portal']['bb_code'])
				{
					$orig_word = array();
					$replacement_word = array();
					obtain_word_list($orig_word, $replacement_word);
					$post_text = str_replace('\"', '"', substr(@preg_replace('#(\>(((?>([^><]+|(?R)))*)\<))#se', "@preg_replace(\$orig_word, \$replacement_word, '\\0')", '>' . $PortalRel['text'] . '<'), 1, -1));
				}else{	
					preg_match_all('/<var class="postImg postImgAligned img-(.*?)" title="(.*?)">&#10;<\/var>/', $PortalRel['text'], $poster, PREG_SET_ORDER);
					preg_match_all('/<var class="postImg" title="(.*?)">&#10;<\/var>/', $PortalRel['text'], $poster2, PREG_SET_ORDER);
					$urlImg = BB_ROOT . 'images/no_poster.png';
					if (@$poster[0][2])
					{
						$urlImg = $poster[0][2];
					}
					elseif (@$poster2[0][1])
					{
						$urlImg = $poster2[0][1];
					}
					$post_text = $PortalRel['text'];
					$pos = strpos($post_text, 'Описание');

					$post_text = substr($post_text, $pos);
					if ($pos = strpos($post_text, 'Сюжет фильма'))
					{
					$pos = strpos($post_text, 'Сюжет фильма');
					$post_text = strip_tags(html_entity_decode(substr($post_text, 0, $pos)));
					}
					elseif ($pos = strpos($post_text, 'О фильме'))
					{
					$pos = strpos($post_text, 'О фильме');
					$post_text = strip_tags(html_entity_decode(substr($post_text, 0, $pos)));
					}
					elseif ($pos = strpos($post_text, '<span class="post-hr">'))
					{
					$pos = strpos($post_text, '<span class="post-hr">');
					$post_text = strip_tags(html_entity_decode(substr($post_text, 0, $pos)));
					}
					elseif ($pos = strpos($post_text, '<div class="sp-wrap">'))
					{
					$pos = strpos($post_text, '<div class="sp-wrap">');
					$post_text = strip_tags(html_entity_decode(substr($post_text, 0, $pos)));
					}
					elseif ($pos = strpos($post_text, '<span class="post-b">'))
					{
					$pos = strpos($post_text, '<span class="post-b">');
					$post_text = strip_tags(html_entity_decode(substr($post_text, 0, $pos)));
					}
					elseif ($pos = strpos($post_text, '<br />'))
					{
					$pos = strpos($post_text, '<br />');
					$post_text = strip_tags(html_entity_decode(substr($post_text, 0, $pos)));
					}
				}
				$i++;
				$template->assign_block_vars('tor', array(
					'TOR_STATUS_ICON' => $bb_cfg['tor_icons'][$rowP['tor_status']],
					'TOPIC_IMG'       => ($bb_cfg['portal']['bb_code']) ? '' : '<img border="1" src="'.$urlImg.'" align="left" style="margin-bottom:8px;margin-right:8px;max-width:260px;max-height:173px;">',
					'TOR_STATUS_TEXT' => $lang['TOR_STATUS_NAME'][$rowP['tor_status']],
					'TEXT'            => $post_text,
					'TOR_SIZE'        => humn_size($rowP['size']),
					'ROW_CLASS'       => (!($i % 2)) ? 'row2' : 'row1',
					'POST_ID'         => $PortalRel['post_id'],
					'TOPIC_ID'        => $rowP['topic_id'],
					'TOPIC_TITLE'     => wbr($rowP['topic_title']),
					'REG_TIME'        => bb_date($rowP['reg_time']),
					'TIME'        	  => bb_date($PortalRel['time']),
					'FORUM_TITLE'     => wbr($rowP['forum_name']),
					'USERNAME'   	  => $username,
					'U_FORUM'         => seo_url(FORUM_URL . $rowP['forum_id'], $rowP['forum_name'], false, true),
					'U_TOPIC'         => seo_url(TOPIC_URL . $rowP['topic_id'], $rowP['topic_title'], false, true),
					'TOR_STATUS'      => $rowP['tor_status'],
					'TOR_TYPE'        => $is_gold,
					'TOPIC_REPLIES'   => $rowP['topic_replies'],
					'TOR_FROZEN'      => ($rowP['tor_status'] == TOR_STATUS_FROZEN || $rowP['tor_status'] == 3 || $rowP['tor_status'] == 4 || $rowP['tor_status'] == 7),
					'NOT_CACHE'       => false,
					'PAGINATION'      => build_topic_pagination(TOPIC_URL . $rowP['topic_id'], $rowP['topic_replies'], $bb_cfg['posts_per_page']),
				));
			}else{
				$template->assign_block_vars('tor', array(
					'NOT_CACHE'       => true,
					'MESSAGE'   	  => 'Кэш раздачи не найден.<br/>Переидите по ссылке для создания кэша: <a class="{tor.DL_CLASS}" href="'.seo_url(TOPIC_URL . $rowP['topic_id'], $rowP['topic_title'], false, true).'">'.$rowP['topic_title'].'</a>',
				));
			}
		}
	}
	if($bb_cfg['portal_relizi']['on_navi'])
	{
		// portal cat
		if (!$forums = $datastore->get('cat_forums'))
		{
			$datastore->update('cat_forums');
			$forums = $datastore->get('cat_forums');
		}
		$cat_title_html = $forums['cat_title_html'];
		$forum_name_html = $forums['forum_name_html'];

		$anon = ANONYMOUS;
		$excluded_forums_csv = '221, 225, 222, 223, 224';
		$only_new = $user->opt_js['only_new'];
		$forums_join_sql = 'f.cat_id = c.cat_id';
		$forums_join_sql .= ($excluded_forums_csv) ? "
			AND f.forum_id NOT IN($excluded_forums_csv)
			AND f.forum_parent NOT IN($excluded_forums_csv)
		" : '';
		$sql = "
			SELECT SQL_CACHE
				f.*
			FROM       ". BB_CATEGORIES ." c
			INNER JOIN ". BB_FORUMS     ." f ON($forums_join_sql)
			AND f.allow_reg_tracker NOT IN (0)
			AND f.allow_porno_topic NOT IN (1)
			AND c.cat_id NOT IN (1,17,18,24,20,25,26,27)
			ORDER BY c.cat_order, f.forum_order
		";
		$cat_forums = array();

		foreach (DB()->fetch_rowset($sql) as $row)
		{
			if (!$cat_id = $row['cat_id'] OR !$forum_id = $row['forum_id'])
			{
				continue;
			}
			$cat_forums[$cat_id]['f'][$forum_id] = $row;
		}
		unset($forums);
		$datastore->rm('cat_forums');

		$forums_count = count($cat_forums);

		$template->assign_vars(array(
			'SHOW_FORUMS'           => $forums_count,
			'NO_FORUMS_MSG'         => ($only_new) ? $lang['NO_NEW_POSTS'] : $lang['NO_FORUMS'],
		));

		foreach ($cat_forums as $cid => $c)
		{
			$template->assign_block_vars('c', array(
				'CAT_ID'    => $cid,
				'CAT_TITLE' => $cat_title_html[$cid],
				'U_VIEWCAT' => "forum.php?c=$cid",
			));

			foreach ($c['f'] as $fid => $f)
			{
				if (!$fname_html =& $forum_name_html[$fid])
				{
					continue;
				}
				$is_sf = $f['forum_parent'];

				if ($is_sf)
				{
					$template->assign_block_vars('c.f.sf', array(
						'SF_ID'   => $fid,
						'SF_NAME' => $fname_html,
					));
					continue;
				}
				$template->assign_block_vars('c.f',	array(
					'FORUM_ID'   => $fid,
					'FORUM_NAME' => $fname_html,
				));
			}
		}
	}
	$pagination = generate_pagination($url, $count, $per_page, $start, false, true, false, 'data-page="true"');
	$template->assign_vars(array(
		'PAGINATION'			=> $pagination,
		'U_PER_PAGE'			=> $url,
		'PER_PAGE'				=> $per_page,
		'S_FORM_ACTION'			=> $url,
		'PAGE_TITLE'            => $lang['PORTAL'],
		'ERROR_MESSAGE'			=> ($errors) ? '<ul type="circle">'. implode_wrap('<li>', '</li>', array_unique($errors)) . '</ul>' : '',
		'QR_SEARCH_ACTION' 		=> 'portal.php?m=sc',
	));
}
print_page('portal.tpl');

